"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var find_up_1 = __importDefault(require("find-up"));
var promises_1 = __importDefault(require("fs/promises"));
var log_1 = __importDefault(require("./helpers/log"));
var FirebaseConfigFileName = 'firebase.json';
exports.default = (function (sites) {
    return function (nextConfig) {
        if (nextConfig === void 0) { nextConfig = {}; }
        if (!sites || sites.length < 1) {
            throw new Error("In order for this to work provide a list of sites to check for rewrites in the firebase.json hosting section.");
        }
        return Object.assign({}, nextConfig, {
            exportPathMap: function (defaultPathMap, _a) {
                var dir = _a.dir;
                return __awaiter(void 0, void 0, void 0, function () {
                    var firebaseConfigPath, firebaseConfig, _b, _c, firebaseConfigHosting, firebaseConfigHostingItems, foundSites, errorFound, _loop_1, sitePath;
                    var _d;
                    return __generator(this, function (_e) {
                        switch (_e.label) {
                            case 0:
                                log_1.default('Validating Firebase Hosting Rules...');
                                return [4 /*yield*/, find_up_1.default(FirebaseConfigFileName, {
                                        cwd: dir,
                                    })];
                            case 1:
                                firebaseConfigPath = _e.sent();
                                if (!firebaseConfigPath) {
                                    throw new Error(FirebaseConfigFileName + " not found looking through directories from " + dir + " to the root.");
                                }
                                log_1.default("Found Firebase config at " + firebaseConfigPath + ".");
                                _c = (_b = JSON).parse;
                                return [4 /*yield*/, promises_1.default.readFile(firebaseConfigPath, 'utf8')];
                            case 2:
                                firebaseConfig = _c.apply(_b, [_e.sent()]);
                                firebaseConfigHosting = firebaseConfig.hosting;
                                if (!firebaseConfigHosting) {
                                    throw new Error("The config " + firebaseConfigPath + " does not contain a \"hosting\" section. Add it and run this again.");
                                }
                                firebaseConfigHostingItems = firebaseConfigHosting.filter(function (hostingConfig) {
                                    return hostingConfig.site && sites.includes(hostingConfig.site);
                                });
                                if (firebaseConfigHostingItems.length === 0) {
                                    throw new Error("The following sites were provided as parameter (" + sites.join(', ') + "), but no hosting entries with matching site were found.");
                                }
                                if (firebaseConfigHostingItems.length !== sites.length) {
                                    foundSites = firebaseConfigHostingItems.map(function (item) { return item.site; });
                                    throw new Error("The following sites were provided as parameter (" + sites.join(', ') + "), but only (" + foundSites.join(', ') + ").");
                                }
                                errorFound = false;
                                _loop_1 = function (sitePath) {
                                    if (sitePath.includes('[')) {
                                        // Replace slugs (i.e. [...varname])
                                        var source_1 = sitePath.replace(/\[\.{3}.+?\]$/gm, '**');
                                        // Check for mistake in remaining params (param starting with .)
                                        if (/\[\.+.+?\]/gm.test(source_1)) {
                                            throw new Error("Dynamic path '" + sitePath + "' section should not start with . (e.g. [.name]) except for slugs at the end (i.e. [...name]). Check https://nextjs.org/docs/routing/dynamic-routes for more details.");
                                        }
                                        // Replace other params with glob
                                        source_1 = source_1.replace(/\[[^.].+?\]/gm, '*');
                                        // Destination just add html (generated by Next.js)
                                        var destination = sitePath + '.html';
                                        var rewriteRule = void 0;
                                        for (var _i = 0, firebaseConfigHostingItems_1 = firebaseConfigHostingItems; _i < firebaseConfigHostingItems_1.length; _i++) {
                                            var hostingEntry = firebaseConfigHostingItems_1[_i];
                                            rewriteRule = (_d = hostingEntry.rewrites) === null || _d === void 0 ? void 0 : _d.find(function (val) { return val.source === source_1; });
                                            if (!rewriteRule) {
                                                errorFound = true;
                                                console.error("\n[ERROR] @ firebase.json [hosting/site=" + hostingEntry.site + "]\nMissing rewrites rule for path '" + sitePath + "'. Include the following rewrite rule in firebase.json.\n");
                                                console.error(JSON.stringify({ source: source_1, destination: destination }));
                                                console.error('\n');
                                            }
                                            else if (rewriteRule.destination !== destination) {
                                                errorFound = true;
                                                console.error("\n[ERROR] @ firebase.json [hosting/site=" + hostingEntry.site + "]\nIncorrect rewrites rule for path '" + sitePath + "'. In firebase.json replace:\n");
                                                console.error(JSON.stringify(rewriteRule));
                                                console.error('\nwith\n');
                                                console.error(JSON.stringify({ source: source_1, destination: destination }));
                                                console.error('');
                                            }
                                        }
                                    }
                                };
                                for (sitePath in defaultPathMap) {
                                    _loop_1(sitePath);
                                }
                                if (errorFound) {
                                    throw new Error("One or more rewrites rules missing or erroneous in '" + firebaseConfigPath + "'.");
                                }
                                else {
                                    log_1.default('[PASS] Firebase Hosting Rules are OK!');
                                }
                                return [2 /*return*/, defaultPathMap];
                        }
                    });
                });
            },
        });
    };
});
//# sourceMappingURL=index.js.map